<!--已处理 processed-->
<template>
  <div class="photonote-processed">
    <el-table v-loading="loading" border :data="photonoteList" @selection-change="handleSelectionChange">
      <el-table-column label="实验室名称" align="left" prop="subName"  width="253" show-overflow-tooltip/>
      <el-table-column label="描述" align="left" prop="describe" show-overflow-tooltip/>
      <el-table-column label="反馈人" align="left" prop="applyName"  width="157" show-overflow-tooltip/>
      <el-table-column label="提交时间" align="left" prop="createTime" width="200" show-overflow-tooltip>
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="处理人" align="left" prop="handleName"  width="135" show-overflow-tooltip/>
      <el-table-column label="处理时间" align="left" prop="handleTime" width="200" show-overflow-tooltip>
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.handleTime) }}</span>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      layout="total, prev, pager, next, sizes, jumper"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改随手拍记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="图片地址" prop="imgUrl">
          <el-input v-model="form.imgUrl" placeholder="请输入图片地址" />
        </el-form-item>
        <el-form-item label="处理人ID" prop="handleUser">
          <el-input v-model="form.handleUser" placeholder="请输入处理人ID" />
        </el-form-item>
        <el-form-item label="处理时间" prop="handleTime">
          <el-date-picker clearable size="small"
                          v-model="form.handleTime"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择处理时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="处理标记 0：待处理 1：已处理">
          <el-radio-group v-model="form.handleStatus">
            <el-radio label="1">请选择字典生成</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="部门id" prop="deptId">
          <el-input v-model="form.deptId" placeholder="请输入部门id" />
        </el-form-item>
        <el-form-item label="部门名称" prop="deptName">
          <el-input v-model="form.deptName" placeholder="请输入部门名称" />
        </el-form-item>
        <el-form-item label="创建人" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入创建人" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="实验室ID" prop="subjectId">
          <el-input v-model="form.subjectId" placeholder="请输入实验室ID" />
        </el-form-item>
        <el-form-item label="描述" prop="describe">
          <el-input v-model="form.describe" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="cancel">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import { listPhotonote, getPhotonote, delPhotonote, addPhotonote, updatePhotonote } from "@/api/laboratory/photonote";


  export default {
    name: "Photonote",
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 随手拍记录表格数据
        photonoteList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize:20,
          imgUrl: null,
          handleUser: null,
          handleTime: null,
          handleStatus: 1,
          deptId: null,
          deptName: null,
          userId: null,
          subjectId: null,
          describe: null
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        }
      };
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询随手拍记录列表 */
      getList() {
        this.loading = true;
        listPhotonote(this.queryParams).then( response => {
          this.photonoteList =  response.rows;
          this.total =  response.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          imgUrl: null,
          handleUser: null,
          handleTime: null,
          handleStatus: 0,
          deptId: null,
          deptName: null,
          userId: null,
          remark: null,
          createBy: null,
          createTime: null,
          updateBy: null,
          updateTime: null,
          subjectId: null,
          describe: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加随手拍记录";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getPhotonote(id).then( response => {
          this.form =  response.data;
          this.open = true;
          this.title = "修改随手拍记录";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updatePhotonote(this.form).then( response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addPhotonote(this.form).then( response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除随手拍记录?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPhotonote(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('laboratory/photonote/export', {
          ...this.queryParams
        }, `laboratory_photonote.xlsx`)
      }
    }
  };
</script>

<style scoped lang="scss">
  .photonote-processed {
    flex:1;
    display: flex!important;
    flex-direction: column;
  }
</style>
